﻿class ColorName{
static var magenta = 0xFF00FF;
static var yellow = 0xFFFF00;
static var cyan = 0x00FFFF;
static var red = 0xFF0000;
static var green = 0x00FF00;
static var blue = 0x0000FF;
static var lightgreen = 0x90EE90;
static var skyblue = 0x87CEEB;
static var violet = 0xEE82EE;
static var pink = 0xFFC0CB;
static var purple = 0x800080;
static var black = 0x000000;
static var white =0xFFFFFF;
static var lightyellow = 0xFFFFE0;
static var brown = 0xA52A2A;
static var crimson = 0xDC143C;
static var orange = 0xFFA500;
static var gray = 0x808080;
static var lightgray = 0xD3D3D3;
static var darkgray = 0xA9A9A9;
static var beige = 0xF5F5DC;
static var darkred = 0x993300;
static var darkgreen = 0x006600;



static function makeCG(colorB, colorE, nn):Array {
var result =[];
var blueB = colorB%256;
var blueE = colorE%256;
var greenB = ((colorB-blueB)/256)%256;
var greenE = ((colorE-blueE)/256)%256;
var redB = (colorB-blueB-greenB*256)/65536;
var redE = (colorE-blueE -greenE*256)/65536;

 	for (var i =0; i<nn; i++)
		 result[i] = blueB+(blueE-blueB)*i/nn + Math.round ((greenB+(greenE-greenB)*i/nn))*256
		                  + Math.round((redB+(redE-redB)*i/nn))*65536
		 return result;  
}

}