﻿//Dice class created by Prof. Koo-Chul Lee 
//Using FlashMX2004, updated from  FlashMX

class CreateDice{
	public var mc:MovieClip;
	private var sizeCube:Number;
	private var cornerSizeRatio:Number;
	private var sd :Number ;
	private var sizeDot:Number;
	private var colA:Array ;
	private var colCorner:Array;
	private var colDot:Number;
   	public var rotMat : Rotation3D ;
    private var aCube:Array; 
	private var currentCube:Array ;
	private var aCube2D:Array ;
	private var corns2D:Array;
	private var corns2D3:Array;
    private var cornsIndex8:Array ;
	private var cornsIndex3:Array ;
    private var dotsC:Array ;
	private var dotData:Array;
	private var distZ:Number;
	private var isIsometric:Boolean;
	
	public function CreateDice(diceMc:MovieClip , diceSize:Number, cornSize:Number , dotSizeR:Number,  colorArray:Array,
						colorCorner:Array,dotCol:Number){
		mc =  diceMc;
		sizeCube = diceSize;
	    cornerSizeRatio =  cornSize;
		sizeDot = sizeCube*dotSizeR;
		colA =  colorArray;
		colCorner = colorCorner;
		colDot = dotCol;
		rotMat = new  Rotation3D();
		 init();
		}// CreateDice
	
	private function init():Void {
		sd = 1- cornerSizeRatio;
		aCube = new Array( [sd, 1, -1],  [1, sd, -1], [1, 1, -sd], [sd, -1, -1], [1, -sd, -1], [1, -1, -sd],
		[-sd, -1, -1], [-1, -sd, -1], [-1, -1, -sd], [-sd, 1, -1], [-1, sd, -1], [-1, 1, -sd],
        [sd, 1, 1], [1, sd, 1], [1, 1, sd], [sd, -1, 1], [1, -sd, 1], [1, -1, sd], [-sd, -1, 1], [-1, -sd, 1],
		 [-1, -1, sd], [-sd, 1, 1], [-1, sd, 1], [-1, 1, sd] );
        currentCube = new Array(24);
		for (var i=0; i<currentCube.length; i++) 
		       currentCube[i] = new Array(0,0,0);
        aCube2D = new Array(24);
		for (var i=0; i<aCube2D.length; i++) 
		       aCube2D[i] = new Array(0,0);
		for (var i=0; i<aCube.length; i++) {
	          for (var j=0; j<3; j++) {
		        aCube[i][j] = aCube[i][j]*sizeCube/2;
	               }}
		 corns2D = new Array(8);
	     	for (var i=0; i<8; i++) 
		        corns2D[i] = new Array(0,0);
		 corns2D3 = new Array(3);
	     	for (var i=0; i<3; i++) 
		        corns2D3[i] = new Array(0,0);
		 cornsIndex8 = new Array( [0, 1, 4, 3, 6, 7, 10, 9], [1, 2, 14, 13, 16, 17,  5, 4], [3, 5, 17, 15, 18, 20, 8, 6],
                                   [0, 9, 11, 23, 21, 12, 14, 2], [7, 8, 20, 19, 22, 23, 11,10], [12, 21, 22, 19, 18, 15, 16, 13])
//Indices of 8 riangles of  corners cut.		
		cornsIndex3 = new Array([2, 1, 0], [3, 4, 5], [8, 7, 6], [9, 10, 11], [12, 13, 14], [17, 16, 15], [18, 19, 20], [23, 22, 21]);
//3D coordiantes of ceters of 21 dots. 
		dotsC =  new Array([0, 0, -1], [1, 0.4, -0.4], [1, -0.4, 0.4], [-0.5, -1, -0.5], [0, -1, 0], [0.5, -1, 0.5],
	    [-0.5, 1, -0.5], [0.5, 1, -0.5], [0.5, 1, 0.5], [-0.5, 1, 0.5], [-1, 0, 0], [-1, 0.5, -0.5], [-1, -0.5, -0.5], 
		[-1, -0.5, 0.5], [-1, 0.5, 0.5], [-0.5, -0.5, 1], [0, -0.5, 1], [0.5, -0.5, 1], [0.5, 0.5, 1], [0, 0.5, 1], [-0.5, 0.5, 1]); 
      for (var i=0; i<21; i++) {
	          for (var j=0; j<3; j++) {
		        dotsC[i][j] = dotsC[i][j]*sizeCube/2;
	               }
             }
		dotData = new Array( 21);	 
    for (var i= 0; i<21; i++)
         dotData[i] = new Array[[0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0]];

    for (var i= 0; i<21; i++)
       dotData[i] = calDotData(dotsC[i]);
		    }//function init
	
	private function calDotData(pt3D1:Array):Array {
       var pt3DA = [[0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0]];
if (Math.abs (pt3D1[0])==(sizeCube/2)) 
   {pt3DA[0] =[pt3D1[0], pt3D1[1] + sizeDot,  pt3D1[2]];
    pt3DA[1] = [pt3D1[0], pt3D1[1] + sizeDot,  pt3D1[2]+sizeDot];
    pt3DA[2] = [pt3D1[0], pt3D1[1],  pt3D1[2]+sizeDot];
    pt3DA[3] = [pt3D1[0], pt3D1[1] -sizeDot,  pt3D1[2]+sizeDot];
    pt3DA[4] = [pt3D1[0], pt3D1[1] -sizeDot,  pt3D1[2]];
    pt3DA[5] = [pt3D1[0], pt3D1[1] -sizeDot,  pt3D1[2]-sizeDot];
    pt3DA[6] = [pt3D1[0], pt3D1[1],  pt3D1[2]-sizeDot];
    pt3DA[7] = [pt3D1[0], pt3D1[1] +sizeDot,  pt3D1[2]-sizeDot];
	   }
 else 
    {if( Math.abs (pt3D1[1])==(sizeCube/2))   
    {pt3DA[0] = [pt3D1[0] + sizeDot,  pt3D1[1],  pt3D1[2]];
      pt3DA[1] = [pt3D1[0] + sizeDot,  pt3D1[1],  pt3D1[2]+ sizeDot];
      pt3DA[2] = [pt3D1[0],  pt3D1[1], pt3D1[2]+sizeDot];
      pt3DA[3] = [pt3D1[0] -sizeDot,  pt3D1[1], pt3D1[2]+sizeDot];
      pt3DA[4] = [pt3D1[0] -sizeDot,  pt3D1[1], pt3D1[2]];
      pt3DA[5] = [pt3D1[0] -sizeDot,  pt3D1[1], pt3D1[2]-sizeDot];
      pt3DA[6] = [pt3D1[0],  pt3D1[1], pt3D1[2]-sizeDot];
      pt3DA[7] = [pt3D1[0] +sizeDot,  pt3D1[1], pt3D1[2]-sizeDot];
	}
   	  else
   {pt3DA[0] =[pt3D1[0],  pt3D1[1] + sizeDot,  pt3D1[2]];
    pt3DA[1] = [pt3D1[0]+sizeDot , pt3D1[1] + sizeDot,  pt3D1[2]];
    pt3DA[2] = [pt3D1[0]+sizeDot , pt3D1[1],  pt3D1[2]];
    pt3DA[3] = [pt3D1[0]+sizeDot , pt3D1[1] - sizeDot,  pt3D1[2]];
    pt3DA[4] = [pt3D1[0],  pt3D1[1] - sizeDot,  pt3D1[2]];
    pt3DA[5] = [pt3D1[0]-sizeDot , pt3D1[1] - sizeDot,  pt3D1[2]];
    pt3DA[6] = [pt3D1[0]-sizeDot , pt3D1[1],  pt3D1[2]];
    pt3DA[7] = [pt3D1[0]-sizeDot , pt3D1[1] + sizeDot,  pt3D1[2]];
	 }
	}
	return pt3DA;
}

	private function drawFilledPoly(corners,  fillC,  alp):Void {
                 var  imax1 = corners.length;
                 mc.lineStyle(0, fillC,  alp);
                 mc.beginFill(fillC, alp);
                  mc.moveTo(corners[0][0],  corners[0][1]);
                  for (var  i = 1; i <imax1; i++)
                 mc.lineTo(corners[i][0], corners[i][1]);
                  mc.lineTo(corners[0][0],  corners[0][1]);
                 mc.endFill();
    }//drawFilledPoly
	
	private function drawDot (oneDot):Void{
        var pt2DA = [[0,0], [0,0], [0,0], [0,0], [0,0], [0,0], [0,0], [0,0]];
        var oneD = [[0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0], [0,0,0]];
	for (var i = 0;  i <8;  i++)
                {oneD[i] =  rotMat.transform3DBody(oneDot[i]);
				 if(isIsometric) oneD[i] = Isom.mTSB(oneD[i]);}
	for (var i = 0;  i <8;  i++)
            pt2DA[i] =  GraUtil.convScreen(oneD[i], distZ);
     mc.lineStyle(0, 0x000000,  100);
     mc.beginFill(colDot, 100);
     mc.moveTo(pt2DA[0][0],  pt2DA[0][1]);
     for (var  i = 1; i <6; i = i + 2)
          mc.curveTo(pt2DA[i][0], pt2DA[i][1], pt2DA[i+1][0], pt2DA[i+1][1]);
      mc.curveTo(pt2DA[7][0], pt2DA[7][1], pt2DA[0][0], pt2DA[0][1]);
      mc.endFill();
   }// drawDot (oneDot):Void

	  public	 function showDice(dist:Number, isIso:Boolean):Void  {
			 distZ = dist;
			 isIsometric = isIso;
		     var imax = aCube.length;
	         var zz :Number ;
		     for (var i = 0;  i <imax;  i++)
                    { currentCube[i]=  rotMat.transform3DBody(aCube[i]);
					  if (isIsometric)  currentCube[i] = Isom.mTSB(currentCube[i]);}
		      for (var i = 0;  i <imax;  i++)
                     aCube2D[i] = GraUtil.convScreen(currentCube[i], distZ);
			 mc.clear();
	    for (var s=0; s<6; s++) {
		for (var k = 0; k< 8; k++)
		             corns2D[k] =  aCube2D[cornsIndex8[s][k]];
	   zz = GraUtil.calZZ(corns2D);
	    if(zz>0)
  {    drawFilledPoly(corns2D,  colA[s],   100);
		 var jb = s*(s+1)/2;
       var je =  (s+1)*(s+2)/2;
   for(var j = jb;  j<je; j++)
       drawDot(dotData[j]);
	   }
    	}
//will cut  8 corners
		for (var s=0; s<8; s++) {
        	for (var ii = 0;  ii <3; ii++)
             corns2D3[ii] =  aCube2D[cornsIndex3[s][ii]];
	   zz = GraUtil.calZZ(corns2D3);
	    if(zz>0)
           drawFilledPoly(corns2D3,  colCorner[s],   100);
//          drawFilledPoly(corns2D3,  0x888888,   100);
		  	}	
	}//showDice()	 
}//class  CreateDice