﻿/*
3차원 물체의 객체를 만든다. 3차원 객체가 실릴 무비 클립을 인수로 받아 들이고 나머지 물체의 속성을 인수로 받는다. 
*/
/*보기로 정6면체를 생성하는 객체를 만들기로 하자  그러면  정6면체의 크기  각면을 칠할 색을정하는  배열을 인수로  준다.*/
class CreateCuboid{
	var mc:MovieClip;
	var size:Number;
	var colA:Array;
	var rh:Number;
	var rd:Number;
	var rotMat:Rotation3D;
	private var aCuboid:Array;
	private var aCuboidRot:Array;
	private var cornsIndex:Array = new Array([0, 1, 2, 3], [0, 4, 5, 1], [1, 5, 6, 2], [0, 3, 7, 4], [2, 6, 7, 3], [4, 7, 6, 5]);
	private var surface:Array  = new Array([[0, 0, 0], [0, 0, 0], [0, 0, 0], [0, 0, 0]], [[0, 0, 0], [0, 0, 0], [0, 0, 0], [0, 0, 0]], [[0, 0, 0], [0, 0, 0], [0, 0, 0], [0, 0, 0]], [[0, 0, 0], [0, 0, 0], [0, 0, 0], [0, 0, 0]], [[0, 0, 0], [0, 0, 0], [0, 0, 0], [0, 0, 0]], [[0, 0, 0], [0, 0, 0], [0, 0, 0], [0, 0, 0]]);

	// constructor  속성 변수를 초기화한다.
	function CreateCuboid(cuboidMc:MovieClip, cuboidSize:Number, rh1:Number, rd1:Number , colorArray:Array) {
		mc = cuboidMc;
		size = cuboidSize;
		colA = colorArray;
		rh =rh1;
		rd = rd1;
		aCuboid = new Array([rh,1, -rd], [rh, -1, -rd], [-rh, -1, -rd], [-rh, 1, -rd], [rh, 1, rd], [rh, -1, rd], [-rh, -1, rd], [-rh, 1, rd]);
	    aCuboidRot =  new Array([rh,1, -rd], [rh, -1, -rd], [-rh, -1, -rd], [-rh, 1, -rd], [rh, 1, rd], [rh, -1, rd], [-rh, -1, rd], [-rh, 1, rd]);
		rotMat = new Rotation3D();
		for (var i = 0; i<8; i++) {
			for (var j = 0; j<3; j++) {
				aCuboid[i][j] = aCuboid[i][j]*cuboidSize/2;
			}
		}
	}
	// function CreateCuboid 
	function showCuboid(alp:Number , IsIso:Boolean) {
		for (var i = 0; i<8; i++) {
			aCuboidRot[i] = rotMat.transform3D(aCuboid[i]);
			if (IsIso) {
				aCuboidRot[i] = Isom.mTSA(aCuboidRot[i]);
			}
					}
		for (var i = 0; i<6; i++) {
			for (var j = 0; j<4; j++) {
				for (var k = 0; k<3; k++) {
					surface[i][j][k] = aCuboidRot[cornsIndex[i][j]][k];
				}
			}
		}
		mc.clear();
		var x01, x21, y01, y21, zz:Number;
		for (var i = 0; i<6; i++) {
			x01 = surface[i][0][0]-surface[i][1][0];
			y01 = surface[i][0][1]-surface[i][1][1];
			x21 = surface[i][2][0]-surface[i][1][0];
			y21 = surface[i][2][1]-surface[i][1][1];
			zz = x01*y21-y01*x21;
			if (zz>0) {
				mc.lineStyle(0, colA[i], alp);
				mc.beginFill(colA[i], alp);
				mc.moveTo(surface[i][0][0], surface[i][0][1]);
				for (var j = 1; j<4; j++) {
					mc.lineTo(surface[i][j][0], surface[i][j][1]);
				}
				mc.lineTo(surface[i][0][0], surface[i][0][1]);
				mc.endFill();
			}
		}
		//for (var i = 0; i< 6; i++) draw surface
	}
	// functoin showCuboid()
}
// class CreateCuboid
