﻿//Class def 
//Written by Prof. Koo-Chul Lee (01/03/2004)
//Rotation3D

class Rotation3D{
	var mat:Array;
	function Rotation3D(){
		mat = new Array([1,0,0],[0,1,0],[0,0,1]);
     }
 function unit ()
    { mat[0] =[1,0,0]; mat[1] = [0,1,0]; mat[2] =[0,0,1];  	}

 function concat (m:Array)
     { var temp :Array =  new Array([1,0,0],[0,1,0],[0,0,1]);
	     for (var i = 0; i<3; i++)
	        for(var j= 0; j<3; j++)
 		        temp[i][j] = mat[i][j];
		 for(var i= 0; i<3; i++)
	      for(var j= 0; j<3; j++)
                 mat[i][j] =  temp[i][0]*m[0][j]+ temp[i][1]*m[1][j] +  temp[i][2]*m[2][j]
 	}

 function rotateX(r:Number)
    {  // r is in degrees - must convert to radians
        var rad = ( r / 180 ) * Math.PI;
        var cosA = Math.cos(rad);
        var sinA = Math.sin(rad);
		var m1:Array  = new Array([1, 0, 0], [0, cosA, sinA], [0, -sinA, cosA]);
        concat(m1);
   }

 function rotateY(r:Number)
    {  // r is in degrees - must convert to radians
        var rad = ( r / 180 ) * Math.PI;
        var cosA = Math.cos(rad);
        var sinA = Math.sin(rad);
		var m1:Array  = new Array([cosA,  0, -sinA], [0, 1, 0], [sinA, 0,  cosA]);
        concat(m1);
   }

 function rotateZ(r:Number)
    {  // r is in degrees - must convert to radians
        var rad = ( r / 180 ) * Math.PI;
        var cosA = Math.cos(rad);
        var sinA = Math.sin(rad);
		var m1:Array  = new Array([cosA, sinA,  0], [ -sinA, cosA, 0], [0,  0,  1]);
        concat(m1);
   }

 function eulerAngles(phi, theta, psi)
 {     var ph = ( phi / 180 ) * Math.PI; 
        var th = ( theta / 180 ) * Math.PI; 
        var ps = ( psi / 180 ) * Math.PI; 
		var sinph = Math.sin(ph);
        var cosph = Math.cos(ph);
        var sinth = Math.sin(th);
        var costh = Math.cos(th);
        var sinps = Math.sin(ps);
        var cosps = Math.cos(ps);
        mat[0][0] = cosps*cosph - costh*sinph*sinps;
        mat[0][1] = -sinps*cosph-costh*sinph*cosps;
        mat[0][2] = sinth*sinph;
	    mat[1][0] = cosps*sinph + costh*cosph*sinps;
	    mat[1][1] = -sinps*sinph+ costh*cosph*cosps;
	    mat[1][2] = -sinth*cosph;
	    mat[2][0] = sinth*sinps;
	    mat[2][1] = sinth*cosps;
	    mat[2][2] = costh;
 }// function eulerian(phi, theta, psi):
 
   function transform3D(pt3D:Array) :Array
    { var result:Array= [0.0, 0.0, 0.0];
        for (var i=0; i<3; i++)
	   	     result[i] = mat[0][i]*pt3D[0] + mat[1][i]*pt3D[1] + mat[2][i]*pt3D[2];
       return result;
    }
	 
   function transform3DBody(pt3D:Array) :Array
    { var result:Array= [0.0, 0.0, 0.0];
        for (var i=0; i<3; i++)
	   	     result[i] = mat[i][0]*pt3D[0] + mat[i][1]*pt3D[1] + mat[i][2]*pt3D[2];
       return result;
    }

}//classRotation3D
